/*
@licstart  The following is the entire license notice for the
JavaScript code in this file.

Copyright (C) 1997-2019 by Dimitri van Heesch

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as published by
the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

@licend  The above is the entire license notice
for the JavaScript code in this file
*/
var NAVTREE =
[
  [ "Cinema 4D C++ SDK", "index.html", [
    [ "Changes in SDK", "page_changes_in_sdk.html", [
      [ "Changes in R23", "page_changes_in_r23.html", null ],
      [ "Changes in S22", "page_changes_in_s22.html", null ],
      [ "Changes in R21", "page_changes_in_r21.html", null ],
      [ "Changes in R20", "page_changes_in_r20.html", null ],
      [ "Changes in R19", "page_changes_in_r19.html", null ],
      [ "Changes in R18", "page_changes_in_r18.html", null ],
      [ "Changes in R17", "page_changes_in_r17.html", null ],
      [ "Changes in R16", "page_changes_in_r16.html", null ],
      [ "Changes in R15", "page_changes_in_r15.html", null ],
      [ "API Change List in R23", "page_api_change_list_in_r23.html", null ],
      [ "API Change List in S22", "page_api_change_list_in_s22.html", null ],
      [ "API Change List in R21", "page_api_change_list_in_r21.html", null ],
      [ "API Change List in R20", "page_api_change_list_in_r20.html", null ],
      [ "API Change List in R19", "page_api_change_list_in_r19.html", null ],
      [ "API Change List in R18", "page_api_change_list_in_r18.html", null ],
      [ "API Change List in R17", "page_api_change_list_in_r17.html", null ],
      [ "API Change List in R16", "page_api_change_list_in_r16.html", null ],
      [ "API Change List in R15", "page_api_change_list_in_r15.html", null ],
      [ "Transition to Cinema 4D R15 API", "page_transition_to_r15_api.html", [
        [ "Changes for Both New and Old Naming Schemes", "page_changes_for_both_new_and_old_naming_scheme.html", null ],
        [ "Changes for New Naming Scheme", "page_changes_for_new_naming_scheme.html", null ],
        [ "Changes for Old Naming Scheme", "page_changes_for_old_naming_scheme.html", null ],
        [ "List Of Name Changes in R15 API", "page_list_of_name_changes_in_r15_api.html", null ]
      ] ]
    ] ],
    [ "Introduction", "page_maxonapi_introduction.html", [
      [ "Getting Started: Introduction", "page_maxonapi_getting_started_introduction.html", null ],
      [ "FAQ: Introduction", "page_maxonapi_faq_introduction.html", null ],
      [ "Cinema 4D C++ SDK", "page_maxonapi_api_sdk.html", [
        [ "SDK Overview", "page_maxonapi_sdk.html", null ],
        [ "API Features", "page_maxonapi_new.html", null ],
        [ "MAXON API Frameworks", "page_maxonapi_frameworks.html", null ]
      ] ],
      [ "Development Overview", "page_maxonapi_dev_requirements.html", [
        [ "Plugin Development", "page_maxonapi_plugin_dev.html", null ],
        [ "Plugin Types", "page_maxonapi_plugintypes.html", null ],
        [ "Project Tool", "page_maxonapi_projecttool.html", null ],
        [ "C++ Techniques", "page_maxonapi_cpp.html", null ],
        [ "Code Style Guide", "page_maxonapi_style_guide.html", null ],
        [ "Development for Microsoft Windows", "page_maxonapi_dev_windows.html", null ],
        [ "Development for macOS", "page_maxonapi_dev_macos.html", null ],
        [ "Development for Linux", "page_maxonapi_dev_linux.html", null ],
        [ "Programming Advice", "page_maxonapi_programming_advice.html", null ],
        [ "Debugging", "page_maxonapi_debug.html", null ]
      ] ],
      [ "Plugin Migration", "page_maxonapi_dev_transition.html", [
        [ "API Transition", "page_maxonapi_transition.html", null ],
        [ "Comparison", "page_maxonapi_compare_legacy.html", null ],
        [ "Replacements", "page_maxonapi_replacements.html", null ]
      ] ]
    ] ],
    [ "Foundations", "page_maxonapi_foundations.html", [
      [ "Getting Started: Foundations", "page_maxonapi_getting_started_foundations.html", null ],
      [ "FAQ: Foundations", "page_maxonapi_faq_foundations.html", null ],
      [ "Classic API Base Classes", "page_maxonapi_legacy_base.html", [
        [ "General Plugin Functionality Overview", "page_overview_general.html", [
          [ "Plugin Functions Manual", "page_manual_module_functions.html", null ],
          [ "General Plugin Information Manual", "page_manual_general_plugin_info.html", null ],
          [ "NodeData Overview", "page_overview_nodedata.html", [
            [ "NodeData::Init() / Alloc and Free Manual", "page_manual_nodedata_init_alloc_free.html", null ],
            [ "NodeData::Message() Manual", "page_manual_nodedata_message.html", null ],
            [ "NodeData::GetDEnabling() Manual", "page_manual_nodedata_getdenabling.html", null ],
            [ "NodeData::GetDDescription() Manual", "page_manual_nodedata_getddescription.html", null ],
            [ "NodeData::SetDParameter() Manual", "page_manual_nodedata_setdparameter.html", null ],
            [ "NodeData::GetDParameter() Manual", "page_manual_nodedata_getdparameter.html", null ],
            [ "NodeData::Read() / NodeData::Write() Manual", "page_manual_nodedata_read_write.html", null ],
            [ "NodeData::CopyTo() Manual", "page_manual_nodedata_copyto.html", null ],
            [ "Draw Manual", "page_manual_draw.html", null ]
          ] ],
          [ "Messages Overview", "page_overview_messages.html", [
            [ "Core Messages Manual", "page_manual_coremessages.html", null ]
          ] ],
          [ "Delegate Manual (Classic)", "page_manual_delegates.html", null ]
        ] ],
        [ "Entity Creation and Destruction Manual (Classic)", "page_manual_entity_creation.html", null ],
        [ "C4DAtom Manual", "page_manual_c4datom.html", null ],
        [ "GeListNode Manual", "page_manual_gelistnode.html", null ],
        [ "BaseList2D Manual", "page_manual_baselist2d.html", null ],
        [ "GeListHead Manual", "page_manual_gelisthead.html", null ],
        [ "DescID Manual", "page_manual_descid.html", null ],
        [ "AtomArray Manual", "page_manual_atomarray.html", null ],
        [ "GeMarker Manual", "page_manual_gemarker.html", null ]
      ] ],
      [ "MAXON API Base Classes", "page_maxonapi_basic_tools.html", [
        [ "Source Processor", "page_maxonapi_sourceprocessor.html", null ],
        [ "Entity Creation", "page_maxonapi_creation.html", null ],
        [ "References", "page_maxonapi_references.html", null ],
        [ "Error System", "page_maxonapi_error_overview.html", [
          [ "Error Handling", "page_maxonapi_error.html", null ],
          [ "Error Result", "page_maxonapi_error_result.html", null ],
          [ "Error Class", "page_maxonapi_error_error.html", null ],
          [ "Error Utility", "page_maxonapi_error_utlity.html", null ],
          [ "Error Types", "page_maxonapi_error_types.html", null ]
        ] ],
        [ "Debug and Output Functions", "page_maxonapi_debug_functions.html", null ],
        [ "Output Syntax", "outputsyntax.html", null ],
        [ "Delegates", "page_maxonapi_delegates.html", null ],
        [ "Observables", "page_maxonapi_observers_overview.html", [
          [ "Observables Declaration", "page_maxonapi_observers_declaration.html", null ],
          [ "Observables Implementation", "page_maxonapi_observers_implementation.html", null ],
          [ "Observables Usage", "page_maxonapi_observers_usage.html", null ]
        ] ],
        [ "Generic Macros", "page_maxonapi_macros.html", null ],
        [ "Initialization", "page_maxonapi_init.html", null ],
        [ "Commands Manual", "page_maxonapi_command.html", null ]
      ] ],
      [ "MAXON API Interfaces", "page_maxonapi_interfaces.html", [
        [ "Interface Basics", "page_maxonapi_interfaces_overview.html", [
          [ "Interface Declaration", "page_maxonapi_interface_declaration.html", null ],
          [ "Using Interfaces", "page_maxonapi_interface_using.html", null ],
          [ "Interface Implementation", "page_maxonapi_interface_implementation.html", null ],
          [ "Interface Methods", "page_maxonapi_interfaces_functions.html", null ],
          [ "Component Bases", "page_maxonapi_interfaces_component_bases.html", null ],
          [ "Interface Annotations", "page_maxonapi_interfaces_annotations.html", null ],
          [ "Interface Inheritance", "page_maxonapi_interface_inheritance.html", null ],
          [ "Reference Types", "page_maxonapi_interfaces_types.html", null ],
          [ "Factories", "page_maxonapi_factories.html", null ]
        ] ],
        [ "Base Interfaces", "page_maxonapi_base_interfaces.html", [
          [ "Object Interface", "page_maxonapi_interfaces_object.html", null ],
          [ "HierarchyObjectInterface Manual", "page_maxonapi_hierarchyobject.html", null ]
        ] ],
        [ "Registries", "page_maxonapi_registry_overview.html", [
          [ "Registry Declaration", "page_maxonapi_registry_declaration.html", null ],
          [ "Registry Registration", "page_maxonapi_registry_register.html", null ],
          [ "Registry Usage", "page_maxonapi_registry_using.html", null ]
        ] ],
        [ "Published Objects", "page_maxonapi_publishedobjects.html", [
          [ "Published Objects Declaration", "page_maxonapi_publishedobjects_delcaration.html", null ],
          [ "Published Objects Implementation", "page_maxonapi_publishedobjects_implementation.html", null ],
          [ "Published Objects Usage", "page_maxonapi_publishedobjects_usage.html", null ]
        ] ],
        [ "Data Descriptions", "page_maxonapi_datadescription_overview.html", [
          [ "Loading Data Descriptions", "page_maxonapi_datadescription_load.html", null ],
          [ "Data Description Categories and Keys", "page_maxonapi_datadescription_categories.html", null ],
          [ "DataDescriptionDefinition Manual", "page_maxonapi_datadescriptiondefinition.html", null ],
          [ "DataDescription Manual", "page_maxonapi_datadescription.html", null ],
          [ "DataDescriptionObjectInterface Manual", "page_maxonapi_datadescriptionobject.html", null ],
          [ "Languages and String Resources", "page_maxonapi_languages_resources.html", null ]
        ] ]
      ] ]
    ] ],
    [ "Data & Algorithms", "page_maxonapi_data.html", [
      [ "Getting Started: Data", "page_maxonapi_getting_started_data.html", null ],
      [ "FAQ: Data", "page_maxonapi_faq_data.html", null ],
      [ "Basic Data Types and Structures", "page_maxonapi_basicdata.html", [
        [ "Classic API Data Types", "page_maxonapi_classicdata.html", [
          [ "Primitive Data Types Manual (Classic)", "page_manual_primitivedata.html", null ],
          [ "Mathematical Functions Manual (Classic)", "page_manual_maths.html", null ],
          [ "Vector Manual (Classic)", "page_manual_vector.html", null ],
          [ "Matrix Manual (Classic)", "page_manual_matrix.html", null ],
          [ "String Manual (Classic)", "page_manual_string.html", null ],
          [ "Filename Manual", "page_manual_filename.html", null ],
          [ "BaseLink Manual", "page_manual_baselink.html", null ],
          [ "BaseTime Manual", "page_manual_basetime.html", null ]
        ] ],
        [ "MAXON API Data Types", "page_maxonapi_apidata.html", [
          [ "Basic Data Types & Mathematics", "page_maxonapi_data_maths.html", [
            [ "Basic Data Types", "page_maxonapi_basic_datatypes.html", null ],
            [ "Vectors", "page_maxonapi_data_vec.html", null ],
            [ "Matrices", "page_maxonapi_data_matrix.html", null ],
            [ "Mathematical Functions", "page_maxonapi_data_math.html", null ],
            [ "Complex Manual", "page_maxonapi_maxon_complex.html", null ],
            [ "Quaternion Manual", "page_maxonapi_maxon_quaternion.html", null ]
          ] ],
          [ "Memory Allocation", "page_maxonapi_memory_allocation.html", null ],
          [ "Strings & Texts", "page_maxonapi_data_strings.html", [
            [ "String Manual", "page_maxonapi_maxon_string.html", null ],
            [ "FormatStatement Manual", "page_maxonapi_formatstatement.html", null ]
          ] ],
          [ "Time-based Types", "page_maxonapi_data_time.html", [
            [ "TimeValue Manual", "page_maxonapi_maxon_timevalue.html", null ],
            [ "UniversalDateTime Manual", "page_maxonapi_maxon_universaldatetime.html", null ],
            [ "LocalDateTime Manual", "page_maxonapi_maxon_localdatetime.html", null ],
            [ "Convert LocalDateTime to/from TM", "page_maxonapi_maxon_convertlocaldatetimetofromtm.html", null ]
          ] ],
          [ "UUID Manual", "page_maxonapi_maxon_uuid.html", null ],
          [ "MAXON Data Type", "page_maxonapi_maxon_datatype.html", null ],
          [ "DataType Manual", "page_maxonapi_data_datatype.html", null ]
        ] ]
      ] ],
      [ "Custom Data Types", "page_overview_custom_data_types.html", [
        [ "DateTimeData Manual", "page_manual_customdata_datetimedata.html", null ]
      ] ],
      [ "Data Containers & Collections", "page_maxonapi_datacontainers.html", [
        [ "Classic API Containers", "page_maxonapi_classic_containers.html", [
          [ "GeData Manual", "page_manual_gedata.html", null ],
          [ "BaseContainer Manual", "page_manual_basecontainer.html", null ]
        ] ],
        [ "MAXON API Containers & Data Collections", "page_maxonapi_maxon_containers.html", [
          [ "Data Manual", "page_maxonapi_data_data.html", null ],
          [ "DataDictionary Manual", "page_maxonapi_data_dictionary.html", null ],
          [ "Resource IDs", "page_maxonapi_resource_id.html", null ],
          [ "BaseArray Manual", "page_maxonapi_basearray.html", null ],
          [ "HashMap Manual", "page_maxonapi_hashmap.html", null ],
          [ "BaseList Manual", "page_maxonapi_baselist.html", null ],
          [ "BaseSort Manual", "page_maxonapi_data_basesort.html", null ],
          [ "Arrays Manual", "page_maxonapi_arrays.html", null ]
        ] ]
      ] ],
      [ "Algorithms", "page_maxonapi_algorithms.html", [
        [ "Stream Conversions Manual", "page_maxonapi_streamconversion.html", null ],
        [ "Random Classes", "page_maxonapi_random.html", null ],
        [ "AES Manual", "page_manual_aes.html", null ],
        [ "AESFile Manual", "page_manual_aesfile.html", null ],
        [ "GeCipher256 Manual", "page_manual_gecipher.html", null ],
        [ "BlendFunctionInterface Manual", "page_maxonapi_blendfunction.html", null ],
        [ "KDTree Manual", "page_maxonapi_kdtree.html", null ],
        [ "FFTInterface Manual", "page_maxonapi_fftinterface.html", null ]
      ] ]
    ] ],
    [ "Application Development", "page_maxonapi_application.html", [
      [ "Getting Started: Application", "page_maxonapi_getting_started_application.html", null ],
      [ "FAQ: Application", "page_maxonapi_faq_application.html", null ],
      [ "Threading", "page_maxonapi_threading.html", [
        [ "Cinema 4D Threads Manual", "page_manual_cinemathreads.html", null ],
        [ "Classic API Threading", "page_maxonapi_classic_threading.html", [
          [ "BaseThread Manual", "page_manual_basethread.html", null ],
          [ "Thread Utility Manual", "page_manual_threadutility.html", null ],
          [ "C4DThread Manual", "page_manual_c4dthread.html", null ],
          [ "Thread Synchronization Manual", "page_manual_threadsync.html", null ]
        ] ],
        [ "MAXON API Threading", "page_maxonapi_maxon_threading.html", [
          [ "Parallel Manual", "page_maxonapi_threading_parallel.html", null ],
          [ "Jobs Manual", "page_maxonapi_threading_jobs.html", null ],
          [ "Threads Manual", "page_maxonapi_threading_threads.html", null ],
          [ "Locks & Synchronization Manual", "page_maxonapi_threading_locks.html", null ],
          [ "Condition Variables Manual", "page_maxonapi_threading_condition.html", null ]
        ] ]
      ] ],
      [ "Files & Media", "page_maxonapi_files_media.html", [
        [ "Classic API Files & Media", "page_maxonapi_classic_files.html", [
          [ "BaseFile Manual", "page_manual_basefile.html", null ],
          [ "HyperFile Manual", "page_manual_hyperfile.html", null ],
          [ "MemoryFileStruct Manual", "page_manual_memoryfile.html", null ],
          [ "ZipFile Manual", "page_manual_zipfile.html", null ],
          [ "File Functions Manual", "page_manual_filefunctions.html", null ],
          [ "BrowseVolumes Manual", "page_manual_browsevolumes.html", null ],
          [ "BrowseFiles Manual", "page_manual_browsefiles.html", null ],
          [ "LocalFileTime Manual", "page_manual_localfiletime.html", null ],
          [ "FileMonitor Manual", "page_manual_filemonitor.html", null ],
          [ "BaseBitmap Manual", "page_manual_basebitmap.html", null ],
          [ "MultipassBitmap Manual", "page_manual_multipassbitmap.html", null ],
          [ "GeClipMap Manual", "page_manual_geclipmap.html", null ],
          [ "MovieLoader Manual", "page_manual_movieloader.html", null ],
          [ "MovieSaver Manual", "page_manual_moviesaver.html", null ]
        ] ],
        [ "MAXON API Files & Media", "page_maxonapi_maxon_files.html", [
          [ "Url Manual", "page_maxonapi_files_url.html", null ],
          [ "FileFormatHandler Manual", "page_maxonapi_fileformathandler.html", null ],
          [ "InputStream Manual", "page_maxonapi_files_inputstream.html", null ],
          [ "OutputStream Manual", "page_maxonapi_files_outputstream.html", null ],
          [ "DescribeIO Manual", "page_maxonapi_files_describeio.html", null ],
          [ "FileMonitor Manual", "page_maxonapi_files_filemonitor.html", null ],
          [ "FileUtilities Manual", "page_maxonapi_fileutilities.html", null ],
          [ "Archives Manual", "page_maxonapi_archives.html", null ],
          [ "Media Sessions Manual", "page_maxonapi_media_converter.html", null ],
          [ "Images Manual", "page_maxonapi_media_image.html", null ]
        ] ]
      ] ],
      [ "GUI & User Interaction", "page_maxonapi_gui_interaction.html", [
        [ "Command Utility Manual", "page_manual_command.html", null ],
        [ "GeDialog Manual", "page_manual_gedialog.html", null ],
        [ "Resource Files Manual", "page_manual_resource_files.html", [
          [ "Dialog Layout", "page_dialog_layout.html", null ],
          [ "Dialog Resource", "page_dialog_resource.html", [
            [ "ARROWBUTTON", "page_dialog_resource__a_r_r_o_w_b_u_t_t_o_n.html", null ],
            [ "BUTTON", "page_dialog_resource__b_u_t_t_o_n.html", null ],
            [ "CHECKBOX", "page_dialog_resource__c_h_e_c_k_b_o_x.html", null ],
            [ "COLORFIELD", "page_dialog_resource__c_o_l_o_r_f_i_e_l_d.html", null ],
            [ "COMBOBOX", "page_dialog_resource__c_o_m_b_o_b_o_x.html", null ],
            [ "DLGGROUP", "page_dialog_resource__d_l_g_g_r_o_u_p.html", null ],
            [ "EDITNUMBER", "page_dialog_resource__e_d_i_t_n_u_m_b_e_r.html", null ],
            [ "EDITNUMBERARROWS", "page_dialog_resource__e_d_i_t_n_u_m_b_e_r_a_r_r_o_w_s.html", null ],
            [ "EDITSLIDER", "page_dialog_resource__e_d_i_t_s_l_i_d_e_r.html", null ],
            [ "EDITTEXT", "page_dialog_resource__e_d_i_t_t_e_x_t.html", null ],
            [ "GROUP", "page_dialog_resource__g_r_o_u_p.html", null ],
            [ "LISTVIEW", "page_dialog_resource__l_i_s_t_v_i_e_w.html", null ],
            [ "MULTILINEEDIT", "page_dialog_resource__m_u_l_t_i_l_i_n_e_e_d_i_t.html", null ],
            [ "POPUPBUTTON", "page_dialog_resource__p_o_p_u_p_b_u_t_t_o_n.html", null ],
            [ "RADIOGADGET", "page_dialog_resource__r_a_d_i_o_g_a_d_g_e_t.html", null ],
            [ "RADIOGROUP", "page_dialog_resource__r_a_d_i_o_g_r_o_u_p.html", null ],
            [ "SCROLLGROUP", "page_dialog_resource__s_c_r_o_l_l_g_r_o_u_p.html", null ],
            [ "SEPARATOR", "page_dialog_resource__s_e_p_a_r_a_t_o_r.html", null ],
            [ "SLIDER", "page_dialog_resource__s_l_i_d_e_r.html", null ],
            [ "SPECIALRADIO", "page_dialog_resource__s_p_e_c_i_a_l_r_a_d_i_o.html", null ],
            [ "SUBDIALOG", "page_dialog_resource__s_u_b_d_i_a_l_o_g.html", null ],
            [ "TAB", "page_dialog_resource__t_a_b.html", null ],
            [ "USERAREA", "page_dialog_resource__u_s_e_r_a_r_e_a.html", null ],
            [ "WINDOWPIN", "page_dialog_resource__w_i_n_d_o_w_p_i_n.html", null ]
          ] ],
          [ "Description Resource", "page_description_resource.html", [
            [ "BOOL", "page_descriptionresource__b_o_o_l.html", null ],
            [ "BASETIME", "page_descriptionresource__b_a_s_e_t_i_m_e.html", null ],
            [ "BUTTON", "page_descriptionresource__b_u_t_t_o_n.html", null ],
            [ "COLOR", "page_descriptionresource__c_o_l_o_r.html", null ],
            [ "DATETIME", "page_descriptionresource__d_a_t_e_t_i_m_e.html", null ],
            [ "DYNAMIC", "page_descriptionresource__d_y_n_a_m_i_c.html", null ],
            [ "FILENAME", "page_descriptionresource__f_i_l_e_n_a_m_e.html", null ],
            [ "FONT", "page_descriptionresource__f_o_n_t.html", null ],
            [ "GRADIENT", "page_descriptionresource__g_r_a_d_i_e_n_t.html", null ],
            [ "HYPERLINK", "page_descriptionresource__h_y_p_e_r_l_i_n_k.html", null ],
            [ "IN_EXCLUDE", "page_descriptionresource__i_n__e_x_c_l_u_d_e.html", null ],
            [ "LINK", "page_descriptionresource__l_i_n_k.html", null ],
            [ "LONG", "page_descriptionresource__l_o_n_g.html", null ],
            [ "MATRIX", "page_descriptionresource__m_a_t_r_i_x.html", null ],
            [ "PRIORITY", "page_descriptionresource__p_r_i_o_r_i_t_y.html", null ],
            [ "REAL", "page_descriptionresource__r_e_a_l.html", null ],
            [ "SEPARATOR", "page_descriptionresource__s_e_p_a_r_a_t_o_r.html", null ],
            [ "SHADERLINK", "page_descriptionresource__s_h_a_d_e_r_l_i_n_k.html", null ],
            [ "SPLINE", "page_descriptionresource__s_p_l_i_n_e.html", null ],
            [ "STATICTEXT", "page_descriptionresource__s_t_a_t_i_c_t_e_x_t.html", null ],
            [ "STRING", "page_descriptionresource__s_t_r_i_n_g.html", null ],
            [ "TEXTURE", "page_descriptionresource__t_e_x_t_u_r_e.html", null ],
            [ "VECTOR", "page_descriptionresource__v_e_c_t_o_r.html", null ]
          ] ]
        ] ],
        [ "Custom GUI Elements", "page_overview_customgui.html", [
          [ "DateTimeControl Manual", "page_manual_customgui_datetime.html", null ]
        ] ],
        [ "GeUserArea Manual", "page_manual_geuserarea.html", null ],
        [ "TriState Manual", "page_manual_tristate.html", null ],
        [ "GUI and Interaction Messages Manual", "page_manual_guimessages.html", null ],
        [ "Description Manual", "page_manual_description.html", null ],
        [ "DynamicDescription Manual", "page_manual_userdata.html", null ],
        [ "Description Settings Manual", "page_manual_description_settings.html", null ],
        [ "BaseView / BaseDraw Manual", "page_manual_basedraw.html", null ]
      ] ],
      [ "Network", "page_maxonapi_network.html", [
        [ "NetworkWebServerInterface Manual", "page_maxonapi_webserver.html", null ],
        [ "TCP Manual", "page_maxonapi_tcp.html", null ],
        [ "UDP Manual", "page_maxonapi_udp.html", null ]
      ] ],
      [ "Plugin Licensing", "page_maxonapi_pluginlicensing.html", null ],
      [ "Miscellaneous Application Classes", "page_maxonapi_app_misc.html", [
        [ "Application Manual", "page_maxonapi_application_manual.html", null ],
        [ "Timer Manual", "page_maxonapi_timer.html", null ],
        [ "Configuration Variables", "page_maxonapi_configuration.html", null ],
        [ "ExecutionInterface Manual", "page_maxonapi_executioninterface.html", null ],
        [ "Unit Tests Manual", "page_maxonapi_unittests.html", null ],
        [ "Machines Manual", "page_maxonapi_machines.html", null ],
        [ "LoggerInterface Manual", "page_maxonapi_loggerinterface.html", null ]
      ] ]
    ] ],
    [ "3D Concepts", "page_maxonapi_3d.html", [
      [ "Getting Started: 3D", "page_maxonapi_getting_started_3_d.html", null ],
      [ "FAQ: 3D", "page_maxonapi_faq_3d.html", null ],
      [ "Production Pipeline", "page_maxonapi_3d_pipeline.html", null ],
      [ "Scene Elements & Data", "page_maxonapi_scene.html", [
        [ "Scene Data Overview", "page_overview_basedocument_module.html", [
          [ "BaseDocument Manual", "page_manual_basedocument.html", null ],
          [ "Layer Manual", "page_manual_layer.html", null ],
          [ "Undo System Manual", "page_manual_undo.html", null ],
          [ "RenderData Manual", "page_manual_renderdata.html", null ],
          [ "BaseVideoPost Manual", "page_manual_basevideopost.html", null ],
          [ "MultipassObject Manual", "page_manual_multipassobject.html", null ]
        ] ],
        [ "Scene Elements Overview", "page_overview_sceneelements.html", [
          [ "BaseObject Manual", "page_manual_baseobject.html", null ],
          [ "CameraObject Manual", "page_manual_cameraobject.html", null ],
          [ "InstanceObject Manual", "page_manual_instanceobject.html", null ],
          [ "BaseTag and VariableTag Manual", "page_manual_basetag.html", null ]
        ] ],
        [ "Materials and Shaders Overview", "page_overview_materials.html", [
          [ "BaseMaterial Manual", "page_manual_basematerial.html", null ],
          [ "Material Manual", "page_manual_material.html", null ],
          [ "BaseShader Manual", "page_manual_baseshader.html", null ],
          [ "InitRenderStruct Manual", "page_manual_initrenderstruct.html", null ],
          [ "TextureTag Manual", "page_manual_texturetag.html", null ],
          [ "Core Nodes Implementation", "page_maxonapi_corenodes_impl.html", null ]
        ] ],
        [ "Animation Overview", "page_overview_animation.html", [
          [ "CTrack Manual", "page_manual_ctrack.html", null ],
          [ "CCurve Manual", "page_manual_ccurve.html", null ],
          [ "CKey Manual", "page_manual_ckey.html", null ]
        ] ],
        [ "Take System Overview", "page_overview_takesystem.html", [
          [ "TakeData Manual", "page_manual_takedata.html", null ],
          [ "BaseTake Manual", "page_manual_basetake.html", null ],
          [ "BaseOverride Manual", "page_manual_baseoverride.html", null ],
          [ "BaseOverrideGroup Manual", "page_manual_baseoverridegroup.html", null ],
          [ "Take System Additional Information", "page_manual_baseoverride_takesystem_additional.html", null ]
        ] ]
      ] ],
      [ "Modeling", "page_maxonapi_modeling.html", [
        [ "VertexColorTag Manual", "page_manual_vertexcolortag.html", null ],
        [ "UVWTag Manual", "page_manual_uvwtag.html", null ],
        [ "NormalTag Manual", "page_manual_normaltag.html", null ],
        [ "Mesh Attributes Interfaces", "page_maxonapi_meshattributes_interfaces.html", null ],
        [ "CustomDataTag Manual", "page_manual_customdatatag.html", null ],
        [ "PolygonReduction Manual", "page_manual_polygonreduction.html", null ],
        [ "ConvexHull Manual", "page_maxonapi_convexhull.html", null ],
        [ "Voronoi 3D Manual", "page_maxonapi_voronoi.html", null ],
        [ "Delaunay 3D Manual", "page_maxonapi_delaunay.html", null ],
        [ "Geometry Utility Manual", "page_maxonapi_libgeom.html", null ]
      ] ],
      [ "Rendering", "page_maxonapi_rendering.html", [
        [ "Render Filter", "page_maxonapi_renderfilter.html", null ],
        [ "Render Filter Implementation", "page_maxonapi_renderfilter_impl.html", null ]
      ] ]
    ] ],
    [ "Modules", "page_maxonapi_modules.html", [
      [ "Batch Render", "page_overview_batch.html", null ],
      [ "BodyPaint", "page_overview_bodypaint.html", null ],
      [ "Character Animation Overview", "page_overview_character_animation.html", [
        [ "CAWeightTag Manual", "page_manual_caweigthtag.html", null ],
        [ "CAWeightMgr Manual", "page_manual_caweigthmgr.html", null ],
        [ "AutoWeightInterface Implementation", "page_maxonapi_autoweigth_impl.html", null ],
        [ "CAPoseMorphTag Manual", "page_manual_caposemorphtag.html", null ],
        [ "CAMorph Manual", "page_manual_camorph.html", null ],
        [ "CAMorphNode Manual", "page_manual_camorphnode.html", null ],
        [ "CAReferencePSD Manual", "page_manual_careferencepsd.html", null ]
      ] ],
      [ "Clouds", "page_overview_clouds.html", null ],
      [ "Color Swatches Overview", "page_overview_colorswatches.html", [
        [ "ColorSwatchData Manual", "page_manual_colorswatchdata.html", null ],
        [ "ColorSwatchGroup Manual", "page_manual_colorswatchgroup.html", null ],
        [ "Color Functions Manual", "page_manual_colorfunctions.html", null ]
      ] ],
      [ "Dynamics", "page_overview_dynamics.html", null ],
      [ "Hair", "page_overview_hair.html", null ],
      [ "LodObject Manual", "page_manual_lodobject.html", null ],
      [ "MoGraph Overview", "page_overview_mograph.html", [
        [ "SoundEffectorData Manual", "page_manual_soundeffectordata.html", null ],
        [ "VoronoiFracture Manual", "page_manual_voronoifracture.html", null ],
        [ "FieldList Manual", "page_manual_fieldlist.html", null ],
        [ "FieldLayerData Manual", "page_manual_fieldlayerdata.html", null ],
        [ "FieldObject Manual", "page_manual_fieldobject.html", null ],
        [ "FieldData Manual", "page_manual_fielddata.html", null ]
      ] ],
      [ "Motion Tracker Overview", "page_overview_motiontracker.html", [
        [ "MotionTrackerObject Manual", "page_manual_motiontrackerobject.html", null ],
        [ "MtFootageData Manual", "page_manual_mtfootagedata.html", null ],
        [ "Mt2dTrackData / Mt2dTrack / MtData Manual", "page_manual_mt2dtrackdata.html", null ]
      ] ],
      [ "Particles", "page_overview_particles.html", null ],
      [ "Presets Browser", "page_overview_presets.html", null ],
      [ "Python", "page_maxonapi_python.html", null ],
      [ "RangeData Manual", "page_manual_rangedata.html", null ],
      [ "Sculpting", "page_overview_sculpting.html", null ],
      [ "Substance Overview", "page_overview_substances.html", [
        [ "Substance Functions Manual", "page_manual_substancefunctions.html", null ],
        [ "Substance Elements Manual", "page_manual_substanceelements.html", null ]
      ] ],
      [ "TeamRender", "page_overview_teamrender.html", null ],
      [ "Thinking Particles", "page_overview_thinkingparticles.html", null ],
      [ "Token System Overview", "page_overview_tokensystem.html", [
        [ "Token System Manual", "page_manual_tokensystem.html", null ]
      ] ],
      [ "Volumes Overview", "page_overview_volumes.html", [
        [ "VolumeObject Manual", "page_manual_volumeobject.html", null ],
        [ "VolumeBuilder Manual", "page_manual_volumebuilder.html", null ],
        [ "VolumeSet Manual", "page_manual_volumeset.html", null ],
        [ "VolumeInterface Manual", "page_maxonapi_volumeinterface.html", null ],
        [ "Volume Tools Manual", "page_maxonapi_volumetools.html", null ]
      ] ],
      [ "XPRESSO", "page_overview_graphview.html", [
        [ "Graph View Calculation (XPresso) Manual", "page_graphview_calculation.html", null ],
        [ "Graph View Data Format (XPresso) Manual", "page_graphview_data_format.html", null ]
      ] ]
    ] ],
    [ "API Reference", null, [
      [ "Classes", "annotated.html", [
        [ "Class List", "annotated.html", "annotated_dup" ],
        [ "Class Index", "classes.html", null ],
        [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
        [ "Class Members", "functions.html", [
          [ "All", "functions.html", "functions_dup" ],
          [ "Functions", "functions_func.html", "functions_func" ],
          [ "Variables", "functions_vars.html", "functions_vars" ],
          [ "Typedefs", "functions_type.html", "functions_type" ],
          [ "Enumerations", "functions_enum.html", null ],
          [ "Enumerator", "functions_eval.html", null ],
          [ "Related Functions", "functions_rela.html", "functions_rela" ]
        ] ]
      ] ],
      [ "Files", "files.html", [
        [ "File List", "files.html", "files_dup" ],
        [ "File Members", "globals.html", [
          [ "All", "globals.html", "globals_dup" ],
          [ "Functions", "globals_func.html", "globals_func" ],
          [ "Variables", "globals_vars.html", "globals_vars" ],
          [ "Typedefs", "globals_type.html", null ],
          [ "Enumerations", "globals_enum.html", "globals_enum" ],
          [ "Enumerator", "globals_eval.html", "globals_eval" ],
          [ "Macros", "globals_defs.html", "globals_defs" ]
        ] ]
      ] ],
      [ "Groups", "modules.html", "modules" ]
    ] ],
    [ "Classic Resource overview", "page_resource_overview.html", null ]
  ] ]
];

var NAVTREEINDEX =
[
"_c_bcircular_8h.html",
"_ffbxexport_8h.html#a12acb3634428eafc5724df6d836f4e64adfc9a0a7178d9786baa95e44cc434091",
"_ohoudinigenerator_8h.html#a3c98418b20c9fd7f0295d6d86135d28ca8a9f901b11cd367296067053d24b7f44",
"algorithms_8h.html#af698db14ce9dcaff5922a4eb4542b734",
"apibase_8h.html#ga81586a76c764e2556f67139907fa5440",
"autoweight__attributes_8h.html#aeaeab1e4b38fe25658611ecd9d04e12a",
"bpsplinetext_8h.html#a634f9f55e799f3052a34590f08100017a639bdcaa044a27f1f0bcf0ab452c7fd2",
"c4d__bitmapfilterstruct_8h.html#ab74fe8efa4c1e7344aed3742a503cb51",
"c4d__colors_8h.html#abc6126af1d45847bc59afa0aa3216b04ac22a6e844186e1bafdb035732daaa9b3",
"c4d__general_8h.html#a89bc204776394bd11c0cec397a6784a4",
"c4d__painter_8h.html#a94d1e7bcdb48cb093b9dc127e32e0872",
"cachetool_8h.html#ae33c78feb670de33d2abf21ec0624531a49b58de65592ab1bb0633ca73bbc29fc",
"class_auto_r_w_locker.html#ad987f836b3211a3dd6a477a93c593dc0",
"class_base_document.html#a8df5c87d4ff8a9f1369df0d723c63678",
"class_base_file.html#ad6033c3eb956d2864f70fe72ba5d906a",
"class_base_override.html#a65c47eedd41b30d8e252886b6cc51cc1",
"class_base_view.html#ad5e6fac284031aee203dc4620e962d2b",
"class_brush_dab_data.html#a69aae6782cece40a60bbc0c83094cd37",
"class_c_a_morph.html#a776a0ac5452e23c760a3273e43e39d62",
"class_c_track.html#a037541879296f790e4b96b93949f1868",
"class_custom_data_type_class.html#accd7a880f8cb936e61c4e7b5c0cabf70",
"class_description_tool_data.html#a179bfa40b6622a8c4baab22aad1841a8",
"class_gadget_ptr.html",
"class_ge_dialog.html#a8383db76cd64d3892e70c85030a1de4c",
"class_ge_user_area.html#a41bad9e39c80b3c17554b73ba78e7734",
"class_gv_node_master.html#a00698ebbbc4231772c5a43efffad9157",
"class_hair_guide_dynamics.html#af90d9f7bfdd8cdd8ef77ed8d20cbc227",
"class_hyper_file.html#a477ed1244d85cf9b0865387fa4cdacc5",
"class_l_min_max.html#a320ccf6222b0b4a14bcc46733efad9cc",
"class_mat_assign_data.html#abfc17853ccb47d00098f0bc8c2bbb2a2",
"class_modeling.html#ac98aa02fba19ac1ca1088d0ac959dc53",
"class_ngon.html#a89fa6ba1194a19bfc4bab3a6ce8aaefc",
"class_parser_cache.html#aade013ccaf1738f7a5018adc772bd9e7",
"class_quick_tab_custom_gui.html#a603a6810efca86e69f80ba8d12d62420",
"class_s_d_k_browser_content_node.html#a458e651af6690959efa2afb96be7d609a2ebde85503cb1618bcd160d9e0e23a56",
"class_s_d_k_reference_object_ptr.html#aaa5f8d00e7e04a6313983f2f7fc1b4fc",
"class_sculpt_brush_tool_data.html#af16990ab9064c67b93fc3037e8585b58",
"class_sculpt_object.html#adf56fd7ea6700bef7a689ace35b1711d",
"class_spline_help.html#a3c3da74a2112bd48bb31f465a8a0da4c",
"class_t_p___p_group_array.html",
"class_tri_state.html",
"class_zip_file.html#a0354e69ecdd237f71dc417458fdbeb96",
"classmaxon_1_1_application.html#a2ce7d6d1ddf138cbcfde78ce5fe06fe0",
"classmaxon_1_1_array_map_1_1_iterator_template.html",
"classmaxon_1_1_atomic_ptr.html#ad5a016eaed3e75f93dbdb7956c31dc8c",
"classmaxon_1_1_base_iterator.html#a8646823da7a2f0fb512527c2770296ea",
"classmaxon_1_1_base_ref.html#a16cc453a8ea862a4e08de4de1bf5d44f",
"classmaxon_1_1_blend_tween_interface.html#a2ee2ee81dd37bee4866899d0804f6e27",
"classmaxon_1_1_block_array_1_1_array_of_blocks.html#a8ed05a724ef60722e2dd86319e88ee54",
"classmaxon_1_1_burst_trie_set.html#ae3e1258562d0989ca5c66b024bc0c659",
"classmaxon_1_1_command_cache_interface.html",
"classmaxon_1_1_condition_variable_interface.html#ad5cdada588fce2e70edf9eba483e82d9",
"classmaxon_1_1_crash_report_property.html#af6c852d5d571b7bea4a327037a12f838",
"classmaxon_1_1_data_description_definition_database_interface.html#aea1e8fc7f653155c48f3f93f027ed20f",
"classmaxon_1_1_data_type_cache.html#a1e4ee7c6b7e2387571eb273cf7c9b910",
"classmaxon_1_1_default_data_type_functions_3_01_t_00_01_d_a_t_a_t_y_p_e_m_o_d_e_1_1_s_m_a_l_l_i_s_p_o_d_01_4.html#a1da7025e34e89249d85c235ae3643668",
"classmaxon_1_1_element_pool.html#a784177271a70cbb294b30ed8f70bb310",
"classmaxon_1_1_file_monitor.html#af1cc8c1009cf7a80ec7008b3fcb2a715",
"classmaxon_1_1_generic_data.html#a55922c6ff1b3efde8d6bc1d8d622065f",
"classmaxon_1_1_grid_accessor_creation_interface.html#a8221c225fd4f77596d31d802430f6ee4",
"classmaxon_1_1_hash_map_entry_base_3_01_k_00_01_unit_type_00_01_e_n_t_r_y_00_01_e_n_t_r_y___h_a_10e56d93d9defadd61498289c0fb01c0.html#a281614fb5030c4270c12cc89fab2c55a",
"classmaxon_1_1_hierarchy_object_iterator.html#a00f008b80917746917b874d00abd02a9",
"classmaxon_1_1_image_interface.html#a4a8384fb88bcb7e25b82fc43ce4bede2",
"classmaxon_1_1_io_file_output_helper.html#aa5a94b9f26c08687f4e6a21698df66af",
"classmaxon_1_1_l_i_m_i_t_3_01_bool_01_4.html#a5ac75d76339341a4635febab28a624a3",
"classmaxon_1_1_local_date_time.html#a372de693ad40b3f42839c8ec6ac845f4",
"classmaxon_1_1_map_interface_1_1_iterator_template.html#a5eb7ef37e52f48f5ba6d5fc191baab25",
"classmaxon_1_1_merge_segment.html#abf80b8c9151fff2fa4cff61f08a9733e",
"classmaxon_1_1_network_ip_addr.html#abe81389e2c6fb8caa93b015bce6c4499",
"classmaxon_1_1_no_error_ptr.html",
"classmaxon_1_1_observable_static_interface.html#add99ad2d22f90a1c1154a61a858295b7",
"classmaxon_1_1_performance_base_array.html#a7b38b9b32e8a69f7c7c4cfb4cd6c2f61",
"classmaxon_1_1_preview_image_data.html#a6c25e34f40d42538189558ce7d381a80",
"classmaxon_1_1_range_map.html#a77dc3d13366632bd066282178e47799c",
"classmaxon_1_1_result.html#a270a73b2ab7e155ecda09e47bd477d4d",
"classmaxon_1_1_ring_buffer_1_1_iterator_template.html#a821bfbe416ec24b9383c4d30bd1c27b1",
"classmaxon_1_1_set_base0.html#a69d2c5ec8faaa3bfa06715bec53a4285",
"classmaxon_1_1_sorted_array.html#a47b4b2eb8112b718f7e468da4681b59b",
"classmaxon_1_1_static_job_group_interface.html#a759f0127c1a21612d431d44828b90da3",
"classmaxon_1_1_strong_ref_handler.html#a183b40c2aa9311be596bcd312914a4ef",
"classmaxon_1_1_terabytes.html#acf3ad30daa635016e7954a0201a890a3",
"classmaxon_1_1_tree_map.html#a8fcc818efee3a8e57d5934c606f05a2b",
"classmaxon_1_1_url_interface.html#a5595c1206f35fea091870a5f3c1c7f9b",
"classmaxon_1_1_volume_tools_interface.html#a958d9c81084a879f22597a8747f77759",
"classmaxon_1_1corenodes_1_1_core_node_group_interface.html#aff46e281c31cbaf8915965c100e20261",
"classmaxon_1_1corenodes_1_1_micro_node_1_1_ports_access.html",
"classmaxon_1_1corenodes_1_1details_1_1_mapped_port_access.html#a923183fb2194db77436060915f5201d2",
"classmaxon_1_1details_1_1_private_vertex_wrapper.html#a536fa3e8ec40882028fe60ba4fcb91ae",
"classmaxon_1_1py_1_1_c_python_library_interface.html#a0768b23f9a2f49bbafcf21f1d55a0cc9",
"classmaxon_1_1py_1_1_c_python_library_interface.html#ad3707ba8cee269fa80940bcf6c6ac74d",
"classmaxon_1_1specialtype_1_1_base_object.html",
"clothtag_8h.html#a26e1124d33b4acdb532c49f6498df549ac742f8e02fc351002e94fa53c3bd3eb7",
"containerbase_8h.html#a417b25b0b02e45534369a9333e3b976a",
"corenodes__helpers_8h.html#addbf975fc1ad8141a556404c9a9c27d1",
"cpython_8h.html#ab37ebd55a186d0a2498da7844702379c",
"cpython__raw_8h.html#a9187bdd555253fba560204644d2f4e8cac21639fa565699bc46bd48c9dbbe746e",
"ctbase_8h.html#a01aea4eb01aa6415eee118b5a5ee3dadacb3b2d4fb70223adc5011ed132c7e7da",
"customgui__itemtree_8h.html#ab52072eb8548f3b4b18ddaaf02bcd61f",
"datadescription__ui_8h.html#a22508ed49ed539aca83a2b292631ad61",
"datatype_8h.html#ga2e7708b5a0052f71ed0f2fa5be94c902",
"dbasedraw_8h.html#a92c4bd66c8074c3d126a069275a0a80ca00b8da5363518a2513e23b4b238df849",
"dbasedraw_8h.html#a92c4bd66c8074c3d126a069275a0a80cab2c52fe65906a403f5bf68b170026f64",
"debugdiagnostics_8h.html",
"dir_873523e70614bbe4c77aa53dfae02963.html",
"drendersettings_8h.html#a4efaf4e07364d6302f598569aa7e55dca0dfc63665cffaeb1357c2fbc02bc8db1",
"drendersettings_8h.html#a4efaf4e07364d6302f598569aa7e55dca9e9c76d23df2d3ee509d9128a7c1ed35",
"dxrefadd_8h.html#a4f79453548dc20926be4b5a000ecbd66a2659a78c52085a70e253ce345aa409bf",
"dynrigidbodytag_8h.html#a52864abcf6ebd8d120995b36fe6ce06ea9aef5f80d81739dbcdc0ef983525d7ae",
"fbox_8h.html#abe821d0fac05333be298917dcb50ee1da07a9d64d247e5d2f30a3597552e42817",
"fileformat__handler_8h.html#a0672fe6806d71b34199336e276afe2d2",
"flinear_8h.html#ac1351f3e26da80ee24b2888ecc68fca6aa98aa57f4ea38313cab5517659093eb1",
"fmidi_8h.html#a6a688c8c331cfa005f7431b606970203abe605fc601c5308389d08bc9162708ee",
"frandom_8h.html#a4eeeead548222804e141df8f1b205ca8ad6e0c200b1ee5f95dd2603cc7a0f6a3c",
"fvrml2export_8h.html#a0fa6e789ab8d8c920f2104ee8c183196ae9a138c28c32f0c8f9cda10256f18994",
"ge__prepass_8h.html#a31e9b6092a35222f9640948458f8746e",
"ge__prepass_8h.html#a67229feb95323b2fde1eaa6d0087b5a0",
"ge__prepass_8h.html#a9d46ced349c539ad959bb212c1991c06",
"ge__prepass_8h.html#ace0731e5f83745233ef419ff0d8e4377",
"ge__sys__math_8h.html#ab805146c8e8bbd45e85f9367657b9160",
"gfx__image__blend__functions_8h.html#aae77c0b29002316da2d36f478474d09fac31b5e59995ff55ae74b6f6188c3f045",
"gfx__image__imagechannels_8h.html#a248853d5de83b5cc5a79ac0267318e8e",
"gfx__image__pixelformats_8h.html#a6542c4c91834b4b0189f5018618395b3",
"globals_x.html",
"group___a_m_s_i.html#gab27024bc3523069c09d6ffb974e40202",
"group___b_a_s_e_b_i_t_m_a_p___d_a_t_a.html#ga671b041f78e549196d7aa0c4aa9281a4",
"group___b_f_m.html#gga40ce4821e27525a1ea4732b0a617c43fa4bf57c16e64e34ed1e1ff79e88bb4ea4",
"group___b_f_m.html#gga40ce4821e27525a1ea4732b0a617c43faca493f8c00d4b4e9a11dc4ba96a19f5f",
"group___b_i_t_d_e_p_t_h.html#ga9d96d6d3459f8d6d27ba1984eac3a695",
"group___b_y_t_e.html",
"group___bake_tex_enums.html#gga60fdbcec551d5cc840170addb0db95d8ad796212ba044eeb8ae35492f51437991",
"group___c4_d_p_l___m_e_s_s_a_g_e_s.html#gabaf1f6c621a7c108616d5b6b6175e43b",
"group___c_c_u_r_v_e.html#ggad672baa099da5b562af3ac06555373f1acd70c29c3b322803edb3984672d5d130",
"group___c_o_f_f_e_e_s_c_r_i_p_t.html#ga0bad5f94a4c3f77766ec69e23717e831",
"group___c_o_p_y_f_l_a_g_s.html#gga415c6ec18efd7a6aacd8a294593ec84dabeba7080c6049a5cebe62a0429f65430",
"group___d_a___t_y_p_e_s.html#ggaead0242d347decdb071818cedf073c1faf35253e46af3aaae1ec87ff54bd0263a",
"group___d_a_t_a_t_y_p_e.html#ga99cdd9cd334eac353edfde72557b16ea",
"group___d_a_t_e_t_i_m_e___c_u_s_t_o_m_g_u_i_s_e_t_t_i_n_g_s.html#ga9a6a4dd462023178105b6f9d1cf19ffe",
"group___d_e_s_c.html#gga8fe220f0393691d2f97f058910c60af9ab7822bcb3a75f63ba9ec1380d8931dab",
"group___d_e_s_c_r_i_p_t_i_o_n___c_u_s_t_o_m_g_u_i_s_e_t_t_i_n_g_s.html#ga80580aa9f0ff274c850a55cd9134b333",
"group___d_i_s_p_l_a_y_f_i_l_t_e_r.html#ggaa6e1e896bc0072115640ef6fefda4889aa5c6bddbe8f4867e90d8fc0bb2fec9ce",
"group___d_r_a_w___p_a_r_a_m_e_t_e_r___o_g_l___c_u_l_l_i_n_g.html#gab631fd246bc0e56bceac3d36f30237c2",
"group___d_t_y_p_e.html#gga153784cd913ed8ebe0f28373c1e2ff6ea81f0971d368681d4eafd1f7a604dfda8",
"group___e_v_m_s_g.html#gaf82f6ca7505b03d9b748b5ba803967f7",
"group___f_i_l_e_d_i_a_l_o_g.html#gga007fe6b8c38b1c401e66ae8dccfca9d6ab50339a10e1de285ac99d4c3990b8693",
"group___f_lbase.html#gac19e35a72d356c69e9317ec951dfc1f6",
"group___g_e___c_m___c_l_i_p_r_e_g_i_o_n.html#gga8adfaa26c9f2e86dcc8fa928d5664e65a6277c52cb1c9c0b35870c08a7c28ef6c",
"group___g_e_t_p_i_x_e_l.html#gacf16132b3f80bce23542422a6b9152da",
"group___ge_font_default_type.html#gga562b7163cdbc2ee5e8945cca2da4f3f7ae68ae118a61f456438263e499fe8b6b6",
"group___gv_data_type.html#gga6b7b47dd702d9e331586d485013fd1eaa8616e0d9d85ce8f775dcf2fc4d8e5cfc",
"group___gv_insert_mode.html#ggab96cba43cc1cf828dde9d5f03c31cf39ae58d909c8d083b5c00669ef1d568c93d",
"group___gv_port_i_d.html#ggaffc386ef27f6052ecb9d5fe65da961e6a0072724ff09c3d6ea44cb19760e502e7",
"group___h_a_i_r___m_s_g___d_a_t_a___t_y_p_e.html#gga0bac399552d80ce0204cd11cf334a8dfab50339a10e1de285ac99d4c3990b8693",
"group___h_y_p_e_r_f_i_l_e_a_r_r_a_y.html#ggac87d251836ef5ada76a866329a271597a8cf125b0e31559ba75a9d9b4f818a554",
"group___i_d___g_v___o_p_g_r_o_u_p___t_y_p_e.html#gaa4495f3c5fd18e24763c20a600b82b87",
"group___i_d___o_p_e_r_a_t_o_r.html#gac632d2d1b06fd1ebb999d6ce11cc99a7",
"group___i_n___e_x_c_l_u_d_e___c_u_s_t_o_m_g_u_i_s_e_t_t_i_n_g_s.html#ga85bc3a6e1e3f66a3259f2c3aff83622e",
"group___i_o.html#gab5dc3cb32bced80471029a964459dad1",
"group___k_e_y.html#ggae82ccf9057d94724392e0e9005209052a7d538b177ab06797012e9ffb1449acd9",
"group___l_i_g_h_t_r_e_s_t_r_i_c_t_i_o_n.html#gab34d1f601dcbaa729a6c7418a5c15402",
"group___m_a_c_h_i_n_e_i_n_f_o.html#ga81fc27515992587af36086f18f5f902b",
"group___m_a_t_h.html#gab38e3d5635d75015807beffd2a9eb6e7",
"group___m_c_o_m_m_a_n_d.html#gab78e8c40a1c95a47899729bf20dca051",
"group___m_d_a_t_a___u_v_r_e_c_t_a_n_g_u_l_a_r_i_z_e.html#ga8f2cd6bd4011186d04e6cfeadec688e6",
"group___m_o_d_e_l_i_n_g___e_r_r_o_r.html#gaa40f45d68ff7db0f59dd3db711eacb6f",
"group___m_p_b___g_e_t_l_a_y_e_r_s.html#gga4580fa4e13bf37d162c6c8f66ebef692a002101f8725e5c78d9f30d87f3fa4c87",
"group___m_s_g___d_e_s_c_r_i_p_t_i_o_n___r_a_n_g_e_g_u_i.html#ga33bd879bb9fd0b08144f998c7bde7103",
"group___mat_preview_size.html#ga797545d22e3bc271137604764c575061",
"group___month_of_year.html#ga797f45d009b8a27ee55e79320b528565",
"group___n_b_i_t.html#gga535c488576eea3f4b947f64aee894932ae3beeb6a6fcb9087858411d33674efdb",
"group___noise_type.html#gga9253d111035d4a83996ec5bbfd3d8963a937f36215c47c470ab284cafd4fb024a",
"group___o_p_e_n_g_l.html#gab38f3775ccf381e765c7516ae4b5f565",
"group___object_types.html#gae1f29ab4057ea05bc2f6277dc3629410",
"group___p_l_u_g_i_n_f_l_a_g___t_o_o_l.html#ga011378af6c7a2e155f3a1dfb2514a392",
"group___p_r_e_f_s.html#gab5b579674614ed2c8d59fb1b5d5558a9",
"group___r_a_n_g_e_c_u_s_t_o_m_g_u_i___c_u_s_t_o_m_g_u_i_s_e_t_t_i_n_g_s.html#ggab04a0655cd1e3bcac5e8f48c18df1a57aa09c0d8168b6b1d458ddca8560c76c38",
"group___r_e_f_l_e_c_t_i_o_n___f_r_e_s_n_e_l___m_e_t_a_l.html#ga04927887d059db90310254d8c5aec9b8",
"group___r_e_f_l_e_c_t_i_o_n___l_a_y_e_r.html#ga9d05853ad9e8823e607fcae8e0232674",
"group___r_e_g_p_a_r_s_e_m_o_d_e.html#gga5e47ea9eb4d43a29c063e2359474d412a6ac3227c311790fb4c3ebbe16920f93a",
"group___r_e_s_o_u_r_c_e_i_m_a_g_e.html#ga3add37292534cbca38de79df6070d74e",
"group___r_e_s_o_u_r_c_e_i_m_a_g_e.html#gaea199c9a26663a67216d894f6acbc757",
"group___raytrace_motion_blur_light_floats.html#gab11aae8bf07d3b4ebe253be520b87867",
"group___s_c_e_n_e_f_i_l_t_e_r.html#ggadbb9f9b19e9bb530fd880f3586dc4546aa45c406a9454cbda432156da18967c50",
"group___s_c_u_l_p_t_o_f_f_s_e_t_f_l_a_g_s.html#gga4de5c1c5d0370159385f485e7fa9060eab50339a10e1de285ac99d4c3990b8693",
"group___s_p_l_i_n_e___c_a_l_l_b_a_c_k.html#ga7d55601be1228258384a834d1f6c215f",
"group___s_t_r_u_c_t_u_r_e_s.html#gadc02c2f4a34b0885f233519e95ccc968",
"group___s_u_b_s_t_a_n_c_e___o_u_t_p_u_t___t_y_p_e.html#gga3b43bf6244d7eceb84a012b0154c0354ad770ba3ce18fa409965dfdf5e7c348e6",
"group___s_y_s_t_e_m.html#ga55efde1e02537513796557cd0f22eb24",
"group___s_y_s_t_e_m.html#gabeaba5a17d14b625903427d6da7afefc",
"group___s_y_s_t_e_m.html#ggac8cea5ef24837817ba71ba19e44e45f6a8d7e99c73cd5a10adaaf4c9f9a520368",
"group___spline_custom_gui_settings.html#ggabc5c98fcc1211af2b80116dd6e0a035da972ce59bfa85f3e060091cf0b1fee9c5",
"group___t_h_r_e_a_d_i_n_g.html#ga7ee043548a3a056d8441e0794832950f",
"group___t_r_a_n_s_m_a_p___f_l_a_g.html#ga1bd3c25966679759744f9d11396792ac",
"group___u_n_d_o_t_y_p_e.html#ggaf0eb9409377ba8388d0ce974c1213f80a8075ed09ab2ca6ceef7ba8495e363f7e",
"group___v_e_r_i_f_i_c_a_t_i_o_n_b_i_t.html#ggaef3b92ecd7a0495498e16523abfecce4a3681160099957486d329b1fa649be065",
"group___v_e_r_s_i_o_n_t_y_p_e.html#ggad2389ae262307ebfb055368e8cc5dd0ea73d722d1f99e14084d41d1f2d375f080",
"group___v_i_e_w_c_o_l_o_r.html#gacfec43717ef44451d7de9eed876900ac",
"group___v_o_l_u_m_e_d_a_t_a___f_i_l_t_e_r.html#ggadbf4762eba8a660d5f9a4798e22e4918a30aa7bbcf0d2f6203b3db4b763f58c97",
"group___v_p_b_u_f_f_e_r.html#ga35b47260177aefa388453243076d6206",
"group___w_p_r_e_f.html#ga24f88a3d6cfc070162d50bc943ea5872",
"group___w_p_r_e_f.html#gac1be41985096a98e804ffc8e669b31b9",
"group___w_p_r_e_f___n_e_t.html#ggae24ea11e50caab24d05b72e49c6bded3a552d104bd40825fdb677ac6713327adb",
"group___z_e_r_o_c_o_n_f_e_r_r_o_r.html#gga0aa8b104b8e0a8552603c6149029c860abdd6691c39f041ba9503e09b701b128d",
"group__group__activeobjectmanagerlibrary.html#ga43b64ed369498d6fea733d27f2a9b7e6",
"group__group__colorchooserlibrary.html#ga051c63a2b0b7d1373172b15ef1aa712d",
"group__group__graphview.html#gad97516b48afb80b80607c851f826a1b4",
"group__group__maxonmath.html#ga89bf851fab11f83ee650fc61bdff2d8d",
"group__group__substance__command__ids.html#ga06f6cdac73e960e9bfa75e1b373858ae",
"group__operatingsystem__callbacks__handlers.html#gaa86ba7395b01d355c614e589445916e4",
"gvdot_8h.html#a103e76ed4bd42f776f7f260080b98b3fa5e90a976fdfed8bcc7c6410b958ead17",
"gvhair__selection_8h.html#abd4fc2111b94dec34e056f8ef38c38e5ac3aaec80a43b807b095e1ab30f0f1bcc",
"gvorder_8h.html",
"gvvect2matrix_8h.html#a22a181a370d3ab8aa40e77637fb5a2f9a06ddae6afc900c46086a44ac5c833d02",
"integer_8h.html",
"jobgroup_8h.html#ggaef695f6186f8c1ceb57390ac5dbe6720a593282ae8693294231a7c9a66eb50f60",
"lib__birender_8h.html#a0c3697b2717360c8e130f786048de198af3a5dd65ebb32f281a9f5ca88b7b4a70",
"lib__ca_8h.html#a0940db9c97ec17f69de91ed16a4d0c70",
"lib__net_8h.html#a30c18344b2bccc72bb73c26d47419d87",
"lib__splinehelp_8h.html",
"mediasession__base_8h.html#a005eb6534375f53cbd57b35778db85bd",
"mediasession__image__export__rla_8h.html#aee300b7bc64359984564553a516f6547",
"mgparticle_8h.html",
"mhairmaterial_8h.html#acdbe0b9425baedbd77beccda99ac3dbea7d7cceddb766e172d08ea1b9fb3b8c69",
"millum_8h.html#ae532194333327ea37ac5798e8af0a53da2ec62093838228e8e1a94fa830f7636c",
"mmaterial_8h.html#a890034ffc30f381fc2a5dfda23ecf0f2adaa740ac8319ea121938f407143ad49e",
"moutliner_8h.html#a05e096ce80431f81e498481ee057b488a282ffe643b0ea680a14ab6c374750849",
"moutliner_8h.html#a05e096ce80431f81e498481ee057b488a591f14d55f389236d9e2b533eb10c109",
"moutliner_8h.html#a05e096ce80431f81e498481ee057b488a88786aaac7288514df365d72bc1550b5",
"moutliner_8h.html#a05e096ce80431f81e498481ee057b488ab883db1832367bd9e7b944bc5677dbf6",
"moutliner_8h.html#a05e096ce80431f81e498481ee057b488ae94260750fa06580a081d0e37a1a5508",
"multiindex_8h.html#a694bc2795d9343eedc81d04a2c854718",
"network__oauth_8h.html#a1dce5cd648e71d7cd92189197204e11b",
"network__zeroconf_8h.html#ab3ac648f2a831a32ad6b50a53aa4270c",
"obase_8h.html#a6f202bbbced0e3a7de5dc2d9029b29b7a724add62588a85278f7b5f9cabd1eee1",
"objectbase_8h.html#ga9b92d18ab9a5a3643c2d6c290590b2f4",
"ocajiggle_8h.html#a4ba3e3f719af1e66760185a8a0115342aa18d4a47e95e36420939e98dea1ec3b5",
"ocamera_8h.html#a7d60538bf88b652d40af16a55f8eb39da9196d1db0aca2a97363f3004b1f1dd38",
"ocapsule_8h.html#aded00f86eb8021d2742e277564cecd43a01ca34945f2492d467c369613c24b11b",
"ocharacterbase_8h.html#a1b48d1aa881b840082d6eaa9741fba14a8ab075eab6ec5f2a1ccf7c2b3a1ec3d1",
"odisc_8h.html#afdbeb6f60de849316884b39d545bb884ad2bb3417166d21758b5fb35d9ba5f931",
"oespline_8h.html#a64066ecf5b68986b979ee4e41964b017a60c2428b5c280f640f582a1dc196612b",
"ofacecapture_8h.html#aa6330de06cf867727bd76475403c83f8ab8b6e381ef066716401e6748ca82125c",
"ohair_8h.html#a55a9b12c8c35de0066afa5625d10d81da2d29aab21d586397868593f6092c3844",
"ohair_8h.html#a55a9b12c8c35de0066afa5625d10d81dadd9e2b63943521552b43fcc293da8dfc",
"olight_8h.html#a467a60e472d9289e59398f5b84ff31d6a5c63df62aa9611167cf553f79c39d64c",
"omograph__cloner_8h.html#ad57961b0da495d56db7a954ebaaff9e0a514fcaadfe44130b1e7bdf2e6637e26e",
"omograph__splinemask_8h.html#a42ac199496d162d935769032ce70eae1a392b6fed7125f752d5e8b8d7aafd26c3",
"omospline_8h.html#a324626c8a5e99e28c43d895e854b3694aee05e37f67e39568af0a625757cbc26f",
"omotiontracker_8h.html#a15f60f1631b78927a1e9efd95cac5a55a8d21a7a142553f07a29a0ba084943d4d",
"onull_8h.html#ac5b95f02723021833cc47477b06a962ca600c278d1e28f05749103b2671a42402",
"op__deflector_8h.html#ab9963002a1a0d81c5dda15cb4c9443aaaa4025a87ab3df1584e8e5aa1ab1f2442",
"op__particledraw_8h.html#abd355410f16e8ce49b24f4a02f6c9380ac126f6e095706061f7b87b5b28f44be4",
"operatingsystem_8h.html#ab583275c1a7d41cf4db635c732d9aa56",
"oremesh_8h.html#ac94dd5c325948c92ffbc3f5dd5848613ad3038d3de2d0d941e7e6e33ae7b38e9b",
"oskyshader_8h.html#adee68fda292365d485e7194ab1b40d1da1ce644ff6caba5556de3c9594ad1c0f9",
"oskyshader_8h.html#adee68fda292365d485e7194ab1b40d1daf51de2ccd231e440f56e24fd866f5e84",
"osplinetext_8h.html#a0dc36413e52d26e632428bb192c9f043a29af788dcb0d8dede49b965d70a6afd3",
"ovolumefilter_8h.html#ac2edcf4e955db86c2deb14eb460607a2ae2a0b4c695425cbe0144edb7c798ae61",
"owrap_8h.html#a9915ba6547d5112db7f4302a15536959aeda8567621b6f1614bc50b8915669e38",
"page_maxonapi_classic_containers.html",
"parser__json_8h.html#af16a8413ed2424a3b8ca1ee895766095a933d51593a5e9d1646b8be028e96b705",
"prefsmaterial_8h.html#a4c1738f3bb1a0d30ddb5bc3b6d10f47aab4726b2fd4cc36aa401f05d3486f8c4d",
"prefstimeline_8h.html#a30fd1e758c6584ac4bbdbf11c47c24bca9153c4b438923ce2650e587654841e48",
"pvfilter_8h.html#a1fba4400e46a0885a4b3c20c5a3e45daa915619e71b409e47048079d9f4c149ac",
"resultbase_8h.html#a3a2f517b121628d936ebff775cd42b5c",
"sse__vector__4i32_8h.html",
"sseconversion_8h.html#ab7a947da4949cddca9b7180205a421f2",
"string_8h.html#gae5c502b02f5e9fbe62fc44063b0cdac3",
"struct_bi_render_lib.html#a8e0ba5ae89b634a25f40382973849464",
"struct_d_w_g_objects_lib.html#aec282d138559b0521abdc0ef531c047f",
"struct_field_input.html#a72aa9a72c56e38ac66339ebf39bebefa",
"struct_gv_dynamic_data.html",
"struct_layer_data.html#a31899c4e06d89693c8845467d77f0384",
"struct_net_library.html#a541d4172002aed3443f2621fb566e0c9",
"struct_pick_session_data_struct.html#aa2143e8ed68dc24f3b46460d98834ab2",
"struct_ray_light.html#af33072138d4c9fd7ec6a4fd77a59c1ea",
"struct_ray_object.html#aebb252bd430136b0c0cbcb03fc88b903",
"struct_sculpt_mouse_data.html#a9fee0ba42bbd588c4132d881b6f8869e",
"struct_tool_resize_data_1_1_tool_resize_falloff_data.html#a291fc56855bf5a240c4ab8d4da7ecc99",
"struct_zip_file_time.html#ab6b63b8cc7cfec85ee9809ae071d97b4",
"structmaxon_1_1_col4.html#a9492aa004ed131ebf98509f8a702cf13",
"structmaxon_1_1_draw_volume.html#a19d12dcbdef1d9a1b9d3f17cb2c4e967",
"structmaxon_1_1_has_erased_base.html#a377ec4d1d42e643e65e4cb75b8a2403e",
"structmaxon_1_1_load_runtime.html#a59cd256d1a1426dd1127cbcb6d08847d",
"structmaxon_1_1_pixel_depth_info_3_01_pix16s_01_4.html",
"structmaxon_1_1_simd_info_1_1_compact.html#a6181465e13ec836a4d8a8524457fb3a8",
"structmaxon_1_1_type_arguments.html#af7de81a04272bcc58d03c743c7240de4",
"structmaxon_1_1_vec4.html#adac64fdf6973f28b58d1197058e5a61f",
"structmaxon_1_1details_1_1_member_type_3_01_t_01_6_6_00_01_g_e_n_e_r_i_c___f_o_r___u_n_k_n_o_w_n___t_y_p_e_01_4.html#a4a6218f17a6b51772891cc3df1b287c0",
"structmaxon_1_1py37_1_1_native_py_traceback_object.html",
"structmaxon_1_1reflection_1_1_invocation_base_3_01void_01_m_a_x_o_n___m_a_k_e___l_i_s_t_07_m_a_x97ab3bd20e8e5e49b1eeddc6837a53fb.html#ad6edcfb48d286dfe59d4667fa174d75a",
"tbaketexture_8h.html#abae2ef2b282172a557e1d1ae67a7271bad2c3e17232d2f8a5e9b3e1ce53fc78b2",
"tcaconstraint_8h.html#a8786051dfa9d07381fb11560a74286e8ae83f8e9a8a2d0a281f3f4212e86d7e05",
"tcameramapping_8h.html#a0f6f84ba155536db14ceea76c1296ea7a4217da096402fd5d33a99c7d512e256b",
"tcarigpart_8h.html#ae1878ac4294a2bc52aea03eb107a1a35a00bc15784b0251b573e278a52ce49311",
"tcarigpart_8h.html#ae1878ac4294a2bc52aea03eb107a1a35aa40cbe20e2323b07ad5f8dbef1689dd8",
"tcawcycle_8h.html#af459f6210575244956b1d7bb6f8c98caa301f555d97dd3176eaaebb5276c38d0f",
"tcompositing_8h.html#afa39703c0a2a2d1b281f92e6b3afce35a9e257441d0b7feb87bdb9ddb2c3b0398",
"tfacepose_8h.html#afa4021aeedf4f0e01dca22c2df3de514a990504970bab68c37e4d84a6bc878d22",
"thairrender_8h.html#ad613c40b11a77c878bbfdfa4896500cbafec36c5250274ad4e9a0c14d992efacb",
"tlworld_8h.html#aa018c78208d4ad1f6c77b769033fa741a9ebf14d5fb8f0a2b68102b194f9f67a0",
"tmotioncam_8h.html#a18077cc96aeaeef83d4cb0263f24b52faa311e8fee23af368757a3ed9d19d4abe",
"toolbevel_8h.html#a662e8dc05a77a4fc06fbc4c04c75a88da0e925a98fc946e0890281e8f2ec59750",
"toolcamirror_8h.html#ad5f695564c910743c9cf4bc57b765017a9f641d178c88b152bc8c4be79566be9f",
"toolcenter_8h.html#a543db39513b2343a4a640d87484ab17daa6d4f378f2695b32d8527c70f682a055",
"toolhaircomb_8h.html#adf05c962997b1b901302b5d6ea922394a4deed874d17fa400327348e0afafe012",
"toolknifeline_8h.html#af7cd2d937e5045ca41e795c83cc5d50cabc0c6edce4a9576ad16dfebc46bba773",
"toolliveselection_8h.html#a83fb0931813f3c29d0a4347c5f11032daacf56db0bcc706050a3f24d633a3303e",
"toolphongselection_8h.html#aa9182ed30c3e66fa4ae3267e505b5a74aca6556155c0466fa907aa1ff70789a52",
"toolsculptbrushknife_8h.html",
"tooluntriangulate_8h.html#a610feb029c19dd7377fa9e0ccae9426aa6e64dba506ace1db1699df5590d6170e",
"tquaternion_8h.html#aeffec68eb0d26e6322d67290de23341eab12581b4d0fcfc54adf980678fdb5218",
"tvolumebuilder_8h.html",
"uv__settings_8h.html#a6d5f633bc9c7cd53de2442927c552f5da209b30d2403353ae12f50a6282f0f063",
"volumeiterators_8h.html#a3de6a800e7a409f2e721d1791d7222eea88559a0cfd8250c9d65970cc145c92d4",
"vpgisetup_8h.html#a8af82fd0323e40b735a9b0fc6274804aa1f3728ed3022b2b0925c047f569481f5",
"vpgpurenderer_8h.html#a4ed4d0913429a6359403e7559cf4f115a050d2835e2189b905e44bd17a742eb57",
"vphairtrace_8h.html#a9832a4daffbdbb84c8e169ddfc2aa03eab0e7633637f5c035cbd17799dff9e167",
"vptext_8h.html#ad60b627c16d2b97f3f3fa899cc3c3901a694729ba5ca8e295ab770ccb5f1712c7",
"vpxmbsampler_8h.html#a0ebdb007a52e0fb64120224a1d7fe76dad645af22928ffd42691180b6b7c53f60",
"xbrick_8h.html#ab78537ed042856398de9bb7946a90a18a4419b363273495a2700fa14aade5ae2c",
"xmg__beat_8h.html#ae718774e0f65cfda8914b0a995e173dda279a75135a7076d7b238a1ee7dbcb162",
"xslabanji_8h.html#af3b89c15707fbc79c5bbda4af74e60cda9058fde21679262c6c5776b36264312c",
"xslacheen_8h.html#a8a143cb921cb028df267faefe3ee35ccad7fb31d9fe99c60f2d7d55b9ac79694e",
"xslafusion_8h.html#a6c0fdfbbc9a1b6fcdf288b8ed9576ef5a19f745d6d4d900c25a238acfd0928fc6",
"xslamabel_8h.html#a1ba1db386160694c59fceec325cdb6b2a9bfc2ac0b318a1b0e0924f1a0383c25c",
"xslanukei_8h.html#a44378b1d6584bac08d41a1ce892ec92aa997f12215ff3dee5fa6aa627f33479bf",
"xslidetool_8h.html#ac289fc2672214c023d0527ec295a3619ada82adcf300f7b82fff0c9699f2ae03a",
"xvariation_8h.html#ac41084cc0992cabbc7b363f0b96f22bdadf69dd8250aac8736d283b95c781cef6"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';