#ifndef UV_SETTINGS_H__
#define UV_SETTINGS_H__

enum
{
	UV_SETTINGS_VIEWPORT_NUMBER = 999,

	UV_SETTINGS_GROUP_DISPLAY = 1000,
	UV_SETTINGS_GROUP_FILTER = 1001,
	UV_SETTINGS_GROUP_BACK = 1002,
	UV_SETTINGS_GROUP_HUD = 1003,
	
	UV_SETTINGS_DISPLAY_ENABLE = 2000,
	UV_SETTINGS_GROUP_OVERLAYS = 2001,
	UV_SETTINGS_DISPLAY_PINS = 2002,
	UV_SETTINGS_DISPLAY_BOUNDARIES = 2003,
	UV_SETTINGS_DISPLAY_BOUNDARIES_NONE = 2004,
	UV_SETTINGS_DISPLAY_BOUNDARIES_SEAMS = 2005,
	UV_SETTINGS_DISPLAY_BOUNDARIES_CONNECTIVITY = 2006,
	UV_SETTINGS_DISPLAY_UVDISPLAY = 2007,
	UV_SETTINGS_DISPLAY_SHADING_OVERLAPPING_POLYGONS = 2008,
	UV_SETTINGS_DISPLAY_SHADING = 2009,
	UV_SETTINGS_DISPLAY_SHADING_DISTORTION = 2010,
	UV_SETTINGS_DISPLAY_SHADING_LINES = 2011,
	UV_SETTINGS_DISPLAY_SHADING_FILLED_POLYGONS = 2012,
	UV_SETTINGS_DISPLAY_SHADING_MULTI_COLOR_ISLANDS = 2013,
	UV_SETTINGS_DISPLAY_OPACITY = 2014,
	UV_SETTINGS_DISPLAY_FILLED_POLYGONS_OPACITY = 2015,
	UV_SETTINGS_DISPLAY_STRETCHMAP_OPACITY = 2016,
	UV_SETTINGS_DISPLAY_COLORED_ISLANDS_OPACITY = 2017,
	UV_SETTINGS_DISPLAY_MODE = 2018,
	UV_SETTINGS_DISPLAY_MODE_AREA = 2019,
	UV_SETTINGS_DISPLAY_MODE_ANGLE = 2020,
	UV_SETTINGS_DISPLAY_EVAL = 2021,
	UV_SETTINGS_DISPLAY_EVAL_PER_UV_SHELL = 2022,
	UV_SETTINGS_DISPLAY_EVAL_PER_OBJECT = 2023,
	UV_SETTINGS_DISPLAY_UVMESH = 2024,
	
	UV_SETTINGS_FILTER_UV_HUD = 3000,
	UV_SETTINGS_FILTER_UV_RULERS = 3001,
	UV_SETTINGS_FILTER_UV_AXIS = 3002,
	UV_SETTINGS_FILTER_UV_UNITS = 3003,
	UV_SETTINGS_FILTER_UV_COMPONENTS = 3004,
	UV_SETTINGS_GROUP_GRID = 3005,
	UV_SETTINGS_FILTER_SHOW_GRID = 3006,
	UV_SETTINGS_FILTER_GRID_SUBDIVS_U = 3007,
	UV_SETTINGS_FILTER_GRID_SUBDIVS_V = 3008,
	UV_SETTINGS_FILTER_SHOW_SUBGRID = 3009,
	UV_SETTINGS_FILTER_SUBGRID_SUBDIVS_U = 3010,
	UV_SETTINGS_FILTER_SUBGRID_SUBDIVS_V = 3011,
	UV_SETTINGS_GROUP_GRID_SPANS = 3012,
	UV_SETTINGS_FILTER_U_LOW = 3013,
	UV_SETTINGS_FILTER_U_HIGH = 3014,
	UV_SETTINGS_FILTER_V_LOW = 3015,
	UV_SETTINGS_FILTER_V_HIGH = 3016,

	UV_SETTINGS_BACK_TEXTURE = 4000,
	UV_SETTINGS_BACK_TEXTURE_EMPTY = 4001,
	UV_SETTINGS_BACK_TEXTURE_CHECKERBOARD = 4002,
	UV_SETTINGS_BACK_TEXTURE_UVMAP = 4003,
	UV_SETTINGS_BACK_TEXTURE_LOAD_TEXTURE = 4004,
	UV_SETTINGS_BACK_TEXTURE_CREATE_TEXTURE = 4005,
	UV_SETTINGS_BACK_MODE = 4006,
	UV_SETTINGS_BACK_MODE_NEAREST = 4007,
	UV_SETTINGS_BACK_MODE_LINEAR = 4008,
	UV_SETTINGS_BACK_KEEP_ASPECT_RATIO = 4009,
	UV_SETTINGS_BACK_CHECKERBOARD_SIZE = 4010,
	UV_SETTINGS_BACK_CHECKERBOARD_SIZE_2 = 4011,
	UV_SETTINGS_BACK_CHECKERBOARD_SIZE_4 = 4012,
	UV_SETTINGS_BACK_CHECKERBOARD_SIZE_8 = 4013,
	UV_SETTINGS_BACK_CHECKERBOARD_SIZE_16 = 4014,
	UV_SETTINGS_BACK_CHECKERBOARD_SIZE_32 = 4015,
	UV_SETTINGS_BACK_CHECKERBOARD_SIZE_64 = 4016,
	UV_SETTINGS_BACK_CHECKERBOARD_SIZE_128 = 4017,
	UV_SETTINGS_BACK_CHECKERBOARD_SIZE_256 = 4018,
	UV_SETTINGS_BACK_CHECKERBOARD_SIZE_512 = 4019,
	UV_SETTINGS_BACK_CHECKERBOARD_SIZE_1024 = 4020,
	UV_SETTINGS_BACK_GRADIENT_OVERLAY = 4021,
	UV_SETTINGS_BACK_OPACITY = 4022,
	UV_SETTINGS_BACK_UVMAP_OPACITY = 4023,
	UV_SETTINGS_GROUP_TILING = 4024,
	UV_SETTINGS_BACK_SHOW_TILED_TEXTURE = 4025,
	UV_SETTINGS_BACK_TILE_U = 4026,
	UV_SETTINGS_BACK_MIN_U = 4027,
	UV_SETTINGS_BACK_MAX_U = 4028,
	UV_SETTINGS_BACK_TILE_V = 4029,
	UV_SETTINGS_BACK_MIN_V = 4030,
	UV_SETTINGS_BACK_MAX_V = 4031,
	UV_SETTINGS_BACK_LINK_GRID_SPANS = 4032,

	UV_SETTINGS_GROUP_INFORMATION = 5000,
	UV_SETTINGS_HUD_TOTAL_POINTS = 5001,
	UV_SETTINGS_HUD_TOTAL_EDGES = 5002,
	UV_SETTINGS_HUD_TOTAL_POLYGONS = 5003,
	UV_SETTINGS_HUD_TOTAL_ISLANDS = 5004,
	UV_SETTINGS_HUD_TOTAL_OVERLAPS = 5005,
	UV_SETTINGS_HUD_TOTAL_REVERSED = 5006,
	UV_SETTINGS_HUD_TOTAL_PINS = 5007,
	UV_SETTINGS_HUD_ACTIVE_TOOL = 5008,
	UV_SETTINGS_HUD_COVERAGE = 5009,
	UV_SETTINGS_HUD_SELECTED_POINTS = 5010,
	UV_SETTINGS_HUD_SELECTED_EDGES = 5011,
	UV_SETTINGS_HUD_SELECTED_POLYGONS = 5012,
	UV_SETTINGS_HUD_SELECTED_ISLANDS = 5013,
	UV_SETTINGS_HUD_SELECTED_OVERLAPS = 5014,
	UV_SETTINGS_HUD_SELECTED_REVERSED = 5015,
	UV_SETTINGS_HUD_SELECTED_PINS = 5016,
	UV_SETTINGS_HUD_GRID_SPACING = 5017,
	UV_SETTINGS_GROUP_CONTROLS = 5018,
	UV_SETTINGS_HUD_BACKGROUND = 5019,
	UV_SETTINGS_HUD_BACKGROUND_OPACITY = 5020,
	UV_SETTINGS_HUD_TEXT = 5021,
	UV_SETTINGS_HUD_TEXT_OPACITY = 5022,
	UV_SETTINGS_HUD_SELECTED = 5023,
	UV_SETTINGS_HUD_SELECTED_OPACITY = 5024,
	UV_SETTINGS_HUD_ALWAYS_ACTIVE = 5025,
};

#endif // UV_SETTINGS_H__
